//----------------------------------------------------------------------//
// zbgL[^R}hL[[h`NX							//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include <memory>
#include <shellapi.h>
#include <mmsystem.h>
#include "UserFunc.h"
#include "MacStart.h"
#include "HKeyRec.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

//---------------------------------------------------------------------------
//WindowsL[ɑΉ邽߂̊g֐
//---------------------------------------------------------------------------
sortcut_inf text_to_shortcut(UnicodeString s)
{
	sortcut_inf si;
	int p = pos_i("Win+", s);
	if (p>0) {
		si.windows_key = true;
		s.Delete(p,4);
	}
	else
		si.windows_key = false;
	si.shortcut = TextToShortCut(s);
	return si;
}
//---------------------------------------------------------------------------
UnicodeString shortcut_to_text(sortcut_inf sc)
{
	UnicodeString s = ShortCutToText(sc.shortcut);
	if (sc.windows_key) s = "Win+" + s;
	return s;
}


//---------------------------------------------------------------------------
// zbgL[^R}hL[[h`NX
//---------------------------------------------------------------------------
TList *HKeyList;
int CmdKwTopIndex;	//R}h`[ڂ̃gbvCfbNX
UnicodeString QxEditor = EmptyStr;

//---------------------------------------------------------------------------
HKeyRec::HKeyRec(HWND h, int uid, sortcut_inf sc)
{
	hOwner = h;
	id	   = uid;
	sc_inf = sc;

	TShiftState ss;
	ShortCutToKey(sc_inf.shortcut, vkcode, ss);
	modflag = 0;
	if (ss.Contains(ssShift)) modflag |= MOD_SHIFT;
	if (ss.Contains(ssAlt))   modflag |= MOD_ALT;
	if (ss.Contains(ssCtrl))  modflag |= MOD_CONTROL;
	if (sc_inf.windows_key)	  modflag |= MOD_WIN;

	for (int i=0; i<MAX_REG_WND; i++) {
		act_class[i] = act_title[i] = act_tit_r[i] = EmptyStr;
		exe_file[i]  = exe_param[i] = exe_dir[i]   = EmptyStr;
		min_class[i] = min_title[i] = min_tit_r[i] = EmptyStr;
		cls_class[i] = cls_title[i] = cls_tit_r[i] = EmptyStr;
		send_key[i] = EmptyStr;
	}

	KeyWord = ico_file = command = qx_macro = EmptyStr;
	sound = wall_paper = EmptyStr;
	key_wait = 50;

	//o^
	if (id>=ID_HOTQ_BASE+1 && id<=ID_HOTQ_BASE+MAX_HOTKEY)
		//zbgL[
		reg_ok = ::RegisterHotKey(hOwner, id, modflag, vkcode);
	else
		//R}h`[
		reg_ok = true;
}
//---------------------------------------------------------------------------
HKeyRec::~HKeyRec()
{
	//o^
	if (id!=0) ::UnregisterHotKey(hOwner, id);
}

//---------------------------------------------------------------------------
// L[𑗏o
//---------------------------------------------------------------------------
void HKeyRec::SendKey(UnicodeString keystr, int wt)
{
	while (
		(HIBYTE(::GetAsyncKeyState(vkcode))) ||
		(HIBYTE(::GetAsyncKeyState(VK_SHIFT))) ||
		(HIBYTE(::GetAsyncKeyState(VK_CONTROL))) ||
		(HIBYTE(::GetAsyncKeyState(VK_MENU))) ||
		(HIBYTE(::GetAsyncKeyState(VK_LWIN))) ||
		(HIBYTE(::GetAsyncKeyState(VK_RWIN)))
	) Sleep(50);

	UnicodeString key;
	while (!keystr.IsEmpty()) {
		Sleep(wt);
		int p = keystr.Pos(",");
		if (p>0) {
			key = keystr.SubString(1,p-1);
			keystr.Delete(1,p);
		}
		else {
			key = keystr;
			keystr = EmptyStr;
		}
		key = key.Trim().UpperCase();
		int flag = 0;
		if (key.SubString(1,1)=="/") {
			key.Delete(1,1);
			flag = KEYEVENTF_KEYUP;
		}
		BYTE vk;
		if 		(key=="ALT")   vk = VK_MENU;
		else if (key=="CTRL")  vk = VK_CONTROL;
		else if (key=="SHIFT") vk = VK_SHIFT;
		else if (key=="TAB")   vk = VK_TAB;
		else if (key=="WIN")   vk = VK_LWIN;
		else if (key=="F1")    vk = VK_F1;
		else if (key=="F2")    vk = VK_F2;
		else if (key=="F3")    vk = VK_F3;
		else if (key=="F4")    vk = VK_F4;
		else if (key=="F5")    vk = VK_F5;
		else if (key=="F6")    vk = VK_F6;
		else if (key=="F7")    vk = VK_F7;
		else if (key=="F8")    vk = VK_F8;
		else if (key=="F9")    vk = VK_F9;
		else if (key=="F10")   vk = VK_F10;
		else if (key=="F11")   vk = VK_F11;
		else if (key=="F12")   vk = VK_F12;
		else				   vk = (BYTE)key[1];
		BYTE sc = (BYTE)::MapVirtualKey(vk, 0);
		::keybd_event(vk, sc, flag, 0);
	}
}

//---------------------------------------------------------------------------
//YEBhẼXgAbv
// wcls : NX   (Sv)
// wtit : ^Cg (Ov)
// wttr : ^Cg (v)
//
// hlist ɃEBhEnhi[ĕԂ
//---------------------------------------------------------------------------
bool HKeyRec::GetHwndList(UnicodeString wcls, UnicodeString wtit, UnicodeString wttr, TList *hlist)
{
	if (wcls.IsEmpty() && wtit.IsEmpty() && wttr.IsEmpty()) return false;

	_TCHAR tbuf[1024], cbuf[256];
	UnicodeString tmp;

	hlist->Clear();
	HWND hTemp = ::GetWindow(Application->Handle, GW_HWNDFIRST);
	while (hTemp) {
		if (::IsWindowVisible(hTemp)) {
			::GetWindowText(hTemp, tbuf, sizeof(tbuf)-1);
			::GetClassName(hTemp,  cbuf, sizeof(cbuf)-1);
			do {
				tmp = tbuf;
				if (!wtit.IsEmpty()) {
					//Ov
					if (tmp.Pos(wtit)!=1) break;
				}
				if (!wttr.IsEmpty()) {
					//v
					if (tmp.Pos(wttr) != (tmp.Length()-wttr.Length()+1)) break;
				}
				tmp = cbuf;
				if (!wcls.IsEmpty() && tmp!=wcls) break;
				hlist->Add(hTemp);
            } while (0);
		}
		hTemp = ::GetWindow(hTemp, GW_HWNDNEXT);
	}

	return (hlist->Count>0);
}

//---------------------------------------------------------------------------
//zbgL[^R}h̎s
//---------------------------------------------------------------------------
void HKeyRec::DoProc()
{
	if (!command.IsEmpty()) {
		//R}h
		HWND hFgWnd = ::GetForegroundWindow();
		UnicodeString cmd, prm;
		int p = command.Pos(" ");
		if (p==0) {
			cmd = command; prm = EmptyStr;
		}
		else {
			cmd = command.SubString(1,p-1);
			prm = command.SubString(p+1, command.Length()-p).Trim();
		}
		if (cmd=="REBOOT" || cmd=="LOGOFF" || cmd=="POWEROFF") {
			do {
				HANDLE htoken;
				TOKEN_PRIVILEGES tknPrvlgs;
				//ANZXg[NJ
				if (!::OpenProcessToken(::GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES|TOKEN_QUERY, &htoken ))
					break;
				//[JӎʎqƓ擾
				if (!::LookupPrivilegeValue(_T(""), SE_SHUTDOWN_NAME, &(tknPrvlgs.Privileges[0].Luid)))
					break;
				tknPrvlgs.PrivilegeCount = 1;
				tknPrvlgs.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
				//ANZXg[NL
				::AdjustTokenPrivileges(htoken, FALSE, &tknPrvlgs, sizeof(TOKEN_PRIVILEGES), NULL, NULL);
				if (::GetLastError() != ERROR_SUCCESS) break;

				if (cmd=="REBOOT")
					::ExitWindowsEx(EWX_REBOOT,   0);	//ċN
				else if (cmd=="LOGOFF")
					::ExitWindowsEx(EWX_LOGOFF,   0);	//OIt
				else
					::ExitWindowsEx(EWX_POWEROFF, 0);	//I
			} while (0);
			return;
		}
		//j^[ȓd̓[hɈڍs
		else if (cmd=="MONITOR_OFF") {
			Sleep(1000);
			::SendMessage(HWND_BROADCAST, WM_SYSCOMMAND, SC_MONITORPOWER, 1);
			//Vistaȍ~̂߂̑΍
			Sleep(1000);
			::SendMessage(HWND_BROADCAST, WM_SYSCOMMAND, SC_MONITORPOWER, 2);
		}
		//tHAOh̃AvP[VI
		else if (cmd=="TERMINATE_APP") {
			DWORD dwPID;
			DWORD last_tid = ::GetWindowThreadProcessId(hFgWnd, &dwPID);
			if (last_tid!=0) {
				DWORD cur_tid  = ::GetCurrentThreadId();
				HWND  last_fcs = NULL;
				if (::AttachThreadInput(cur_tid, last_tid, TRUE)) {
					last_fcs = ::GetFocus();
					::AttachThreadInput(cur_tid, last_tid, FALSE);
				}
				_TCHAR tbuf[1024];
				::GetWindowText(hFgWnd, tbuf, sizeof(tbuf)-1);
				UnicodeString tmpstr = UnicodeString("[") + tbuf + "]\n I܂?";
				::SetForegroundWindow(Application->Handle);
				Application->ProcessMessages();
				//I
				if (Application->MessageBox(tmpstr.c_str(), _T("x"), MB_OKCANCEL|MB_ICONWARNING)==IDOK) {
					HANDLE hProcess = ::OpenProcess(PROCESS_TERMINATE, FALSE, dwPID); 
					if (hProcess) ::TerminateProcess(hProcess, (UINT) -1); 
				}
				//LZꍇ̓tH[JX߂
				else {
					cur_tid = ::GetCurrentThreadId();
					if (::AttachThreadInput(cur_tid, last_tid, TRUE)) {
						::SetForegroundWindow(hFgWnd);
						::SetFocus(last_fcs);
						::AttachThreadInput(cur_tid, last_tid, FALSE);
					}
				}
			}
		}
		//tHAOhEBhEő剻
		else if (cmd=="MAXIMIZE_FGWND") {
			if (hFgWnd) ::ShowWindow(hFgWnd, SW_MAXIMIZE);
		}
		//tHAOhEBhEŏ
		else if (cmd=="MINIMIZE_FGWND") {
			if (hFgWnd) ::ShowWindow(hFgWnd, SW_MINIMIZE);
		}
		//tHAOhEBhẼTCY
		else if (cmd=="RESTORE_FGWND") {
			if (hFgWnd) ::ShowWindow(hFgWnd, SW_RESTORE);
		}
		//tHAOhEBhE
		else if (cmd=="CLOSE_FGWND") {
			if (hFgWnd) ::PostMessage(hFgWnd, WM_SYSCOMMAND, SC_CLOSE,0);
		}
		//tHAOhEBhËʒuETCYݒ
		else if (cmd=="SETPOS_FGWND") {
			if (hFgWnd) {
				RECT rc;
				::GetWindowRect(hFgWnd, &rc);
				int wp[4];
				wp[0] = rc.left;
				wp[1] = rc.top;
				wp[2] = rc.right - rc.left;
				wp[3] = rc.bottom - rc.top;
				std::unique_ptr<TStringList> s(new TStringList());
				s->CommaText = prm;
				if (s->Count<=4) {
					for (int i=0; i<s->Count; i++) {
						if		(SameText(s->Strings[i], "MAX"))
							wp[i] = (i%2==0) ? Screen->Width : Screen->Height;
						else if (SameText(s->Strings[i], "HALF"))
							wp[i] = ((i%2==0) ? Screen->Width : Screen->Height)/2;
						else if (!SameText(s->Strings[i], "*"))
							wp[i] = s->Strings[i].ToIntDef(0);
					}
					::SetWindowPos(hFgWnd, HWND_TOP,
						wp[0], wp[1], wp[2], wp[3], SWP_SHOWWINDOW);
				}
			}

		}
		//bchCůJ
		else if (cmd=="CD_OPEN" || cmd=="CD_CLOSE") {
			MCI_OPEN_PARMS mci_prm;
			mci_prm.lpstrDeviceType = (LPCTSTR)MCI_DEVTYPE_CD_AUDIO;
			DWORD flag = MCI_OPEN_TYPE|MCI_OPEN_TYPE_ID|MCI_OPEN_SHAREABLE|MCI_WAIT;
			if (!prm.IsEmpty()) {
				if (prm[prm.Length()]!=':') prm += ":";
				mci_prm.lpstrElementName = prm.c_str();
				flag |= MCI_OPEN_ELEMENT;
			}
			if (mciSendCommand(0, MCI_OPEN, flag, (DWORD)&mci_prm) == 0) {
				mciSendCommand(mci_prm.wDeviceID, MCI_SET, 
					((cmd=="CD_OPEN") ? MCI_SET_DOOR_OPEN : MCI_SET_DOOR_CLOSED), NULL);
				mciSendCommand(mci_prm.wDeviceID, MCI_CLOSE, MCI_WAIT, NULL);
			}

		}
		else {
			if (cmd=="ALL_MINIMIZE") 		//Sčŏ	(WindowsL[ + M)
				SendKey("WIN,M,/M,/WIN", 0);
			else if (cmd=="ALL_RESTORE")	//Sčő剻	(WindowsL[ + Shift + M)
				SendKey("WIN,SHIFT,M,/M,/SHIFT,/WIN", 0);
			else if (cmd=="CHANGE_TASK")  	//^XN؂ւ (Alt + Tab)
				SendKey("ALT,TAB,/TAB,/ALT", 0);
		}
	}

	std::unique_ptr<TList> wlist(new TList());
	//ŏ
	for (int i=0; i<MAX_REG_WND; i++) {
		if (!GetHwndList(min_class[i], min_title[i], min_tit_r[i], wlist.get())) continue;
		for (int j=0; j<wlist->Count; j++) {
			HWND hw = (HWND)wlist->Items[j];
			::ShowWindow(hw, SW_MINIMIZE);
		}
	}

	//
	for (int i=0; i<MAX_REG_WND; i++) {
		if (!GetHwndList(cls_class[i], cls_title[i], cls_tit_r[i], wlist.get())) continue;
		for (int j=0; j<wlist->Count; j++) {
			HWND hw = (HWND)wlist->Items[j];
			::PostMessage(hw, WM_SYSCOMMAND, SC_CLOSE,0);
		}
	}

	//ANeBu
	for (int i=0; i<MAX_REG_WND; i++) {
		if (GetHwndList(act_class[i], act_title[i], act_tit_r[i], wlist.get())) {
			for (int j=0; j<wlist->Count; j++) {
				HWND hw = (HWND)wlist->Items[j];
				if (::IsIconic(hw)) ::SendMessage(hw, WM_SYSCOMMAND, SC_RESTORE, 0);
				::SetForegroundWindow(hw);
			}
		}
		//N
		else if (!exe_file[i].IsEmpty()) {
			if (!send_key[i].IsEmpty())
				//Av̓͂LɂȂ܂ő҂
				execute_ex(exe_file[i], exe_param[i], exe_dir[i], SW_SHOWNORMAL, true);
			else
				execute_ex(exe_file[i], exe_param[i], exe_dir[i]);
		}
		//L[o
		if (!send_key[i].IsEmpty()) SendKey(send_key[i], key_wait);
	}

	//QS}N̎s
	if (!qx_macro.IsEmpty()) {
		HWND hQxWnd = ::FindWindow(_T("QXWclassframe32"), NULL);
		if (hQxWnd) {
			if (::IsIconic(hQxWnd)) ::SendMessage(hQxWnd, WM_SYSCOMMAND, SC_RESTORE, 0);
			::SetForegroundWindow(hQxWnd);
			if (QxMacStarter->QxMacro.IsEmpty()) {
				QxMacStarter->hQxWnd  = hQxWnd;
				QxMacStarter->QxMacro = qx_macro;
			}
			//̃}Ns
			else
				::MessageBeep(MB_ICONEXCLAMATION);
		}
		else if (!QxEditor.IsEmpty()) {
			UnicodeString prmstr = "-M"+qx_macro;
			execute_ex(QxEditor, prmstr);
		}
	}
}
//---------------------------------------------------------------------------
