//----------------------------------------------------------------------//
//	ėpʊ֐														//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include <memory>
#include <Filectrl.hpp>
#include <ShellAPI.hpp>
#include <shlobj.h>
#include <algorithm>
#include <utilcls.h>
#include "UserFunc.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

//---------------------------------------------------------------------------
// wZp[^̑O̕擾
// Zp[^Ȃꍇ́Â܂ܕԂ
//---------------------------------------------------------------------------
UnicodeString get_tkn(UnicodeString s, UnicodeString sp)
{
	int p = s.Pos(sp);
	if (p==0)
		return s;
	else
		return s.SubString(1,p-1);
}

//---------------------------------------------------------------------------
// wZp[^̌̕擾
// Zp[^Ȃꍇ́AEmptyStr Ԃ
//---------------------------------------------------------------------------
UnicodeString get_tkn_r(UnicodeString s, UnicodeString sp)
{
	int p = s.Pos(sp);
	if (p==0)
		return EmptyStr;
	else
		return s.SubString(p+sp.Length(), s.Length()-(p-sp.Length()+1));
}

//---------------------------------------------------------------------------
//召ʂɕ (2oCgΉ)
//  wd: 
//   s: Ώە
//---------------------------------------------------------------------------
int pos_i(UnicodeString wd, UnicodeString s)
{
	if (wd.IsEmpty()) return 0;
	s  = s.UpperCase();
	wd = wd.UpperCase();
	return s.Pos(wd);
}

//---------------------------------------------------------------------------
//sJEg
//---------------------------------------------------------------------------
int count_lins(UnicodeString s)
{
	int l = 0;
	if (!s.IsEmpty()) {
		for (int i=1; i<=s.Length(); i++) if (s[i]=='\n') l++;
		if (s[s.Length()]!='\n') l++;
	}
	return l;
}

//---------------------------------------------------------------------------
// dnam fBNgȉ̑SĂ g=ext ̃t@CXgAbv
//---------------------------------------------------------------------------
void get_filelist(UnicodeString dnam, TStringList *FilList, UnicodeString ext, bool sort_sw)
{
	if (dnam.IsEmpty()) return;
	if (dnam[dnam.Length()]=='\\') dnam.Delete(dnam.Length(),1);
	if (!DirectoryExists(dnam)) return;

	if (ext.IsEmpty()) return;
	if (ext[1]!='.') ext = "."+ext;

	std::unique_ptr<TStringList> FldList(new TStringList());
	FldList->Sorted = sort_sw;
	FilList->Sorted = sort_sw;
	TSearchRec sr;
	FldList->Add(dnam);
	while (FldList->Count>0) {
		if (FindFirst(FldList->Strings[0]+"\\*", faAnyFile, sr)==0) {
			do {
				if ((sr.Name != ".") && (sr.Name != "..")) {
					if ((sr.Attr & faDirectory)!=0)
						FldList->Add(FldList->Strings[0] +"\\" +sr.Name);
					else if (SameText(ExtractFileExt(sr.Name), ext))
						FilList->Add(FldList->Strings[0] + "\\"+ sr.Name);
				}
		    } while (FindNext(sr)==0);
		}
		FindClose(sr);
		FldList->Delete(0);
	}
}

//---------------------------------------------------------------------------
//fnam ɃhCuȂ
//st@C̃fBNg̑΃t@Cɕς
//t@C݂Ȃ false Ԃ
//---------------------------------------------------------------------------
bool get_file_name_r(UnicodeString &fnam)
{
	if (fnam.IsEmpty()) return false;
	if (ExtractFileDrive(fnam).IsEmpty())
		fnam = ExtractFilePath(Application->ExeName) + fnam;
	return FileExists(fnam);
}

//---------------------------------------------------------------------------
// wt@CJ(ShellExecute)
// cmd V[gJbg̏ꍇ̓N擾ċNAprmfld͖
// ftHg(ȗ) prm="", fld="",  nShowCmd=SW_SHOWNORMAL, wait=false;
//---------------------------------------------------------------------------
bool execute_ex(UnicodeString cmd, UnicodeString prm, UnicodeString fld, 
	int nShowCmd, bool wait)
{
	if (ExtractFileExt(cmd.UpperCase())==".LNK") {
		// V[gJbg̃N擾(MSIɂ̑Ή)
		typedef UINT(WINAPI *FP_MsiGetShortcutTarget)(LPCTSTR,LPTSTR,LPTSTR,LPTSTR);
		typedef UINT(WINAPI *FP_MsiGetComponentPath)(LPCTSTR,LPCTSTR,LPTSTR,DWORD*);
		_TCHAR l_cmd[MAX_PATH+1]; l_cmd[0] = '\0';

		HMODULE hMsiDLL;
		bool msi_flag;
		try {
			_TCHAR prd_cod[40], cmp_id[40];
			hMsiDLL = ::LoadLibrary(_T("MSI.DLL"));	if (hMsiDLL==NULL) throw Exception(EmptyStr);
			FP_MsiGetShortcutTarget MsiGetShortcutTarget
				= (FP_MsiGetShortcutTarget)::GetProcAddress(hMsiDLL,"MsiGetShortcutTargetW");
			if (MsiGetShortcutTarget==NULL) throw Exception(EmptyStr);
			FP_MsiGetComponentPath MsiGetComponentPath 
				= (FP_MsiGetComponentPath)::GetProcAddress(hMsiDLL,"MsiGetComponentPathW");
			if (MsiGetComponentPath==NULL) throw Exception(EmptyStr);
			if (MsiGetShortcutTarget(cmd.c_str(), prd_cod, NULL, cmp_id) != ERROR_SUCCESS)
				throw Exception(EmptyStr);
			DWORD bufsz = sizeof(l_cmd);
			MsiGetComponentPath(prd_cod, cmp_id, l_cmd, &bufsz);
			if (bufsz==0) throw Exception(EmptyStr);
			if (hMsiDLL) ::FreeLibrary(hMsiDLL);
			msi_flag = true;	//N擾ɐ
		}
		catch (...) {
			if (hMsiDLL) ::FreeLibrary(hMsiDLL);
			msi_flag = false;
		}

		//V[gJbg̏擾
		try {
			::CoInitialize(NULL);
			TComInterface<IShellLink>   psl;
			TComInterface<IPersistFile> ppf;
			if (SUCCEEDED(::CoCreateInstance(CLSID_ShellLink, NULL,
				CLSCTX_INPROC_SERVER, IID_IShellLink, (void **)&psl)))
			{
				WCHAR wcLinkFile[MAX_PATH+1];
				_TCHAR l_prm[MAX_PATH+1];
				_TCHAR l_fld[MAX_PATH+1];
				if (FAILED(psl->QueryInterface(IID_IPersistFile, (void **)&ppf))) throw Exception(EmptyStr);
				::MultiByteToWideChar(CP_UTF8, 0, UTF8String(cmd).c_str(), -1, wcLinkFile, MAX_PATH);
				if (ppf->Load(wcLinkFile, STGM_READ) != S_OK)	throw Exception(EmptyStr);
				if (psl->Resolve(NULL, SLR_UPDATE) != NOERROR) throw Exception(EmptyStr);
				if (!msi_flag) psl->GetPath(l_cmd, 256, NULL, 0);
				psl->GetArguments(l_prm, 256);
				psl->GetWorkingDirectory(l_fld, 256);
				psl->GetShowCmd(&nShowCmd);
				prm = l_prm;
				fld = l_fld;
			}
			::CoUninitialize();
			cmd = l_cmd;
		}
		catch (...) {
			l_cmd[0] = '\0';
			::CoUninitialize();
		}
	}

	if (wait) {
		//NAv̓͂LɂȂ܂ő҂
		STARTUPINFO sinf;
		::ZeroMemory(&sinf, sizeof(sinf) );
		sinf.cb = sizeof(sinf);
		sinf.wShowWindow = (WORD)nShowCmd;
		PROCESS_INFORMATION pinf;
		if (!prm.IsEmpty()) cmd += (" " + prm);
		if (::CreateProcess(NULL, cmd.c_str(), NULL,NULL, FALSE, 0, NULL,
			(fld.IsEmpty()? NULL : fld.c_str()), &sinf,&pinf) != 0)
		{
			::WaitForInputIdle(pinf.hProcess, 30000);
			::CloseHandle(pinf.hProcess);
			::CloseHandle(pinf.hThread);
			return true;
		}
		else
			return false;
	}
	else
		return (::ShellExecute(NULL, _T("open"),
			cmd.c_str(), prm.c_str(), fld.c_str(), nShowCmd) > (HINSTANCE)32);
}

//---------------------------------------------------------------------------
//ComboBox ɗǉ
//---------------------------------------------------------------------------
void add_ComboBox_history(TComboBox *cp, UnicodeString kwd)
{
	if (!kwd.IsEmpty()) {
		TStrings *lp = cp->Items;
		int idx = lp->IndexOf(kwd);
		if (idx!=0) {
			if (idx>0) lp->Delete(idx);
			lp->Insert(0, kwd);	//擪ɒǉ
		}
		cp->Text = kwd;
	}
}
//---------------------------------------------------------------------------
//ComboBox ɗ폜
//---------------------------------------------------------------------------
void del_ComboBox_history(TComboBox *cp, UnicodeString kwd)
{
	if (!kwd.IsEmpty()) {
		TStrings *lp = cp->Items;
		int idx = lp->IndexOf(kwd);
		if (idx!=-1) lp->Delete(idx);
		cp->Text = EmptyStr;
	}
}

//---------------------------------------------------------------------------
//̕ OR/AND 
//       wd:  (̏ꍇ͔p܂͑Sp󔒂ŋ؂j
//        s: Ώە
//   and_sw: AND		(default = false)
//   not_sw: NOT		(default = false)
//  case_sw: 召	(default = false)
//---------------------------------------------------------------------------
bool find_mlt(UnicodeString  wd, UnicodeString s,
	bool and_sw, bool not_sw, bool case_sw)
{
	if (wd.IsEmpty()) return 1;

	//ꃊXg쐬
	std::unique_ptr<TStringList> wlst(new TStringList());
	for (;;) {
		if (wd.IsEmpty()) break;
		int p = wd.Pos(" ");
		if (p==1)
			wd.Delete(1,1);
		else if (p>1) {
			wlst->Add(wd.SubString(1,p-1));  wd.Delete(1,p);
		}
		else {
			p = wd.Pos("@");
			if (p==1)
				wd.Delete(1,1);
			else if (p>1) {
				wlst->Add(wd.SubString(1,p-1));  wd.Delete(1,p+1);
			}
			else {
				wlst->Add(wd); break;
			}
		}
	}

	//󔒂^uϊ
	for (int i=0; i<wlst->Count; i++) {
		UnicodeString tmpstr = wlst->Strings[i];
		tmpstr = ReplaceStr(tmpstr, "\\s", " ");
		tmpstr = ReplaceStr(tmpstr, "\\t", "\t");
		wlst->Strings[i] = tmpstr;
	}

	//
	bool ret = and_sw;
	for (int i=0; i<wlst->Count; i++) {
		int p = case_sw? s.Pos(wlst->Strings[i]) : pos_i(wlst->Strings[i], s);
		if (!not_sw) {
			//܂
			if (p>0) {
				//ꂩ
				if (!and_sw) { ret = true; break; }
			}
			else {
				//SĂ
				if (and_sw) { ret = false; break; }
			}
		}
		else {
			//܂܂Ȃ
			if (p==0) {
				//ꂩ
				if (!and_sw) { ret = true; break; }
			}
			else {
				//SĂ
				if (and_sw) { ret = false; break; }
			}
		}
	}

	return ret;
}

//---------------------------------------------------------------------------
// ComboBox ̍ڂǍ
//---------------------------------------------------------------------------
void load_ComboBoxItems(TComboBox *cp, UsrIniFile *ip, UnicodeString sct, int max_items)
{
	if (sct.IsEmpty()) sct = cp->Name;
	cp->Clear();

	for (int i=0; i<max_items; i++) {
		UnicodeString itm_str = ip->ReadString(sct, "Item"+IntToStr(i+1), EmptyStr);
		if (itm_str.IsEmpty()) break;
		if (cp->Items->IndexOf(itm_str)==-1) cp->Items->Add(itm_str);
	}
}
//---------------------------------------------------------------------------
// ComboBox ̍ڂۑ
//---------------------------------------------------------------------------
void save_ComboBoxItems(TComboBox *cp, UsrIniFile *ip, UnicodeString sct, int max_items)
{
	if (sct.IsEmpty()) sct = cp->Name;

	for (int i=0; i<max_items; i++) {
		UnicodeString itm_str = EmptyStr;
		if (i<cp->Items->Count) itm_str = cp->Items->Strings[i];
		ip->WriteString(sct, "Item"+IntToStr(i+1), itm_str);
	}
}

//---------------------------------------------------------------------------
// ̓WJ
//---------------------------------------------------------------------------
UnicodeString exp_FormatStr(UnicodeString fstr)
{
	//ϊ
	const _TCHAR WeekStrJ[7][4]
		= {_T(""), _T(""), _T(""), _T(""), _T(""), _T(""), _T("y")};
	const _TCHAR WeekStrE[7][10]
		= {_T("Sunday"), _T("Monday"), _T("Tuesday"), _T("Wednesday"),
		   _T("Thursday"), _T("Friday"), _T("Saturday")};
	const _TCHAR MonthStrE[12][10]
		= {_T("January"), _T("February"), _T("March"), _T("April"), _T("May"), _T("June"),
		   _T("July"), _T("August"), _T("September"), _T("October"), _T("November"), _T("December")};

	if (fstr.Pos("\\")==0) return fstr;

	int w = Now().DayOfWeek();
	unsigned short y,m,d;
	DecodeDate(Now(), y, m, d);
	UnicodeString cur_m = MonthStrE[m-1];
	UnicodeString cur_w = WeekStrE[w-1];
	UnicodeString swd, rwd;
	int p;
	for (int i=0; i<17; i++) {
		switch (i) {
		case  0: swd = "\\n";  rwd = "\r\n";						   break;
		case  1: swd = "\\t";  rwd = "\t";							   break;
		case  2: swd = "\\Y";  rwd = FormatDateTime("yyyy", Now());    break;
		case  3: swd = "\\y";  rwd = FormatDateTime("yy",   Now());    break;
		case  4: swd = "\\MM"; rwd = cur_m; 						   break;
		case  5: swd = "\\M";  rwd = cur_m.SubString(1,3);			   break;
		case  6: swd = "\\0m"; rwd = FormatDateTime("mm",	Now());    break;
		case  7: swd = "\\m";  rwd = FormatDateTime("m",	Now());    break;
		case  8: swd = "\\0d"; rwd = FormatDateTime("dd",	Now());    break;
		case  9: swd = "\\d";  rwd = FormatDateTime("d",	Now());    break;
		case 10: swd = "\\WW"; rwd = cur_w; 						   break;
		case 11: swd = "\\W";  rwd = cur_w.SubString(1,3);			   break;
		case 12: swd = "\\w";  rwd = WeekStrJ[w-1]; 				   break;
		case 13: swd = "\\T";  rwd = FormatDateTime("hh:nn:ss",Now()); break;
		case 14: swd = "\\H";  rwd = FormatDateTime("hh",	Now());    break;
		case 15: swd = "\\N";  rwd = FormatDateTime("nn",	Now());    break;
		case 16: swd = "\\S";  rwd = FormatDateTime("ss",	Now());    break;
		}
		while ((p = fstr.Pos(swd)) != 0)
			fstr.Delete(p, swd.Length()).Insert(rwd, p);
	}

	return fstr;
}

//---------------------------------------------------------------------------
// Xg{bNX̍ڂɌr` (wi̔]F)
//---------------------------------------------------------------------------
void draw_ListItemLine(TListBox *lp, int idx)
{
	lp->Canvas->Pen->Mode  = pmNot;
	lp->Canvas->Pen->Width = 2;
	if (idx!=-1) {
		TRect r = lp->ItemRect(idx);
		int   y = (lp->ItemIndex<idx)? r.Bottom : r.Top;
		lp->Canvas->MoveTo(0, y);
		lp->Canvas->LineTo(lp->Width, y);
	}
}

//---------------------------------------------------------------------------
//AvP[Ṽo[W擾
//---------------------------------------------------------------------------
UnicodeString get_VersionStr(UnicodeString fnam)
{
	UnicodeString verstr = EmptyStr;
	DWORD  dwReserved;
	DWORD  dwSize	= ::GetFileVersionInfoSize(fnam.c_str(), &dwReserved);
	LPVOID lpBuffer = ::HeapAlloc(::GetProcessHeap(), HEAP_ZERO_MEMORY, dwSize);
	if (lpBuffer) {
		if (::GetFileVersionInfo(fnam.c_str(), NULL, dwSize,lpBuffer)) {
			LPVOID lpLang = NULL;
			UINT   dwLength;
			if (::VerQueryValue(lpBuffer, _T("\\VarFileInfo\\Translation"), &lpLang, &dwLength)) {
				WORD *lpTranslate = (WORD*)lpLang;
				LPVOID lpStr;
				UnicodeString subblock;
				subblock.sprintf(_T("\\StringFileInfo\\%04x%04x\\FileVersion"), *lpTranslate, *(lpTranslate+1));
				if (::VerQueryValue(lpBuffer, subblock.c_str(), &lpStr, &dwLength))
					verstr.sprintf(_T("%s"), lpStr);
			}
		}
		::HeapFree(::GetProcessHeap(), 0, lpBuffer);
	}
	return verstr;
}
//---------------------------------------------------------------------------
int get_VersionNo()
{
	UnicodeString verstr = get_VersionStr(Application->ExeName);
	verstr = ReplaceStr(verstr.SubString(1,5), ".", EmptyStr);
	return verstr.ToIntDef(0);
}

//---------------------------------------------------------------------------
//wEBhẼNX擾
//---------------------------------------------------------------------------
UnicodeString get_ClassName(HWND hWnd)
{
	UnicodeString rstr = EmptyStr;
	_TCHAR cbuf[256];
	if (::GetClassName(hWnd, cbuf, sizeof(cbuf)-1)>0) rstr = cbuf;
	return rstr;
}
//---------------------------------------------------------------------------
