//----------------------------------------------------------------------//
// zbgL[ꗗ														//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include "HKeyRec.h"
#include "UIniFile.h"
#include "Unit3.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
THotKeyHelp *HotKeyHelp;

//---------------------------------------------------------------------------
__fastcall THotKeyHelp::THotKeyHelp(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall THotKeyHelp::FormShow(TObject *Sender)
{
	UnicodeString sct = "HotKeyList";
	SetBounds(
		IniFile->ReadInteger(sct,"WinWidth",	500),
		IniFile->ReadInteger(sct,"WinHeight",	400),
		IniFile->ReadInteger(sct,"WinLeft",		(Screen->Width-Width)/2),
		IniFile->ReadInteger(sct,"WinTop",		(Screen->Height-Height)/2));

	HKeyListBox->TabWidth = (::GetDialogBaseUnits() & 0x0000ffff) * 10;
	HKeyListBox->Items->Clear();

	for (int i=0; i<HKeyList->Count; i++) {
		HKeyRec *kp = (HKeyRec*)HKeyList->Items[i];
		if (kp->id>=ID_HOTQ_BASE+1 && kp->id<=ID_HOTQ_BASE+MAX_HOTKEY) {
			UnicodeString keystr = shortcut_to_text(kp->sc_inf);
			UnicodeString cntstr = EmptyStr;
			if (!kp->command.IsEmpty())
				cntstr = "R}h: "+kp->command;
			else if (!kp->exe_file[0].IsEmpty()) {
				cntstr = kp->exe_file[0];
				UnicodeString ext = ExtractFileExt(cntstr.UpperCase());
				if (ext==".EXE" || ext==".COM" || ext==".BAT")
					cntstr = ExtractFileName(cntstr);
				if (!kp->exe_param[0].IsEmpty()) cntstr += (" "+kp->exe_param[0]);
			}
			else if (!kp->act_class[0].IsEmpty() || !kp->act_title[i].IsEmpty() || !kp->act_tit_r[i].IsEmpty()) {
				cntstr = "ANeBu: "+kp->act_class[0];
				if (!kp->act_title[i].IsEmpty()) cntstr += (","+kp->act_title[i]);
				if (!kp->act_tit_r[i].IsEmpty()) cntstr += (","+kp->act_tit_r[i]);
			}
			else if (!kp->qx_macro.IsEmpty())
				cntstr = kp->qx_macro;
			else if (!kp->sound.IsEmpty())
				cntstr = kp->sound;
			else if (!kp->wall_paper.IsEmpty())
				cntstr = kp->wall_paper;
			HKeyListBox->Items->Add(keystr + "\t" + cntstr);
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall THotKeyHelp::FormClose(TObject *Sender,
      TCloseAction &Action)
{
	UnicodeString sct = "HotKeyList";
	IniFile->WriteInteger(sct,"WinLeft",	Left);
	IniFile->WriteInteger(sct,"WinTop",		Top);
	IniFile->WriteInteger(sct,"WinWidth",	Width);
	IniFile->WriteInteger(sct,"WinHeight",	Height);
	IniFile->UpdateFile();
}

//---------------------------------------------------------------------------
void __fastcall THotKeyHelp::FormPaint(TObject *Sender)
{
	//TCYύXObv`
	RECT rc = Rect(
		ClientWidth - ::GetSystemMetrics(SM_CXHSCROLL),
		ClientHeight - ::GetSystemMetrics(SM_CYVSCROLL),
		ClientWidth, ClientHeight);
	::DrawFrameControl(Canvas->Handle, &rc, DFC_SCROLL,	DFCS_SCROLLSIZEGRIP);
}
//---------------------------------------------------------------------------
void __fastcall THotKeyHelp::FormResize(TObject *Sender)
{
	Repaint();
}

//---------------------------------------------------------------------------
void __fastcall THotKeyHelp::CloseBtnClick(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------

